VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Thumbs.db"
   ClientHeight    =   4410
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   10110
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4410
   ScaleWidth      =   10110
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog comdlg 
      Left            =   9705
      Top             =   -150
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   " Thumbs.db|Thumbs.db"
   End
   Begin VB.PictureBox pbThumbnailImage 
      AutoRedraw      =   -1  'True
      Height          =   3390
      Left            =   6450
      ScaleHeight     =   58.738
      ScaleMode       =   6  'Millimeter
      ScaleWidth      =   61.119
      TabIndex        =   4
      Top             =   900
      Width           =   3525
   End
   Begin VB.ListBox lbThumbnails 
      Height          =   3375
      Left            =   120
      TabIndex        =   3
      Top             =   900
      Width           =   6240
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   ""
      Height          =   360
      Left            =   8745
      TabIndex        =   2
      Top             =   450
      Width           =   1215
   End
   Begin VB.TextBox tbStorageFileName 
      BackColor       =   &H8000000F&
      Height          =   345
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   465
      Width           =   8550
   End
   Begin VB.Label Label1 
      Caption         =   ":"
      Height          =   225
      Left            =   120
      TabIndex        =   0
      Top             =   165
      Width           =   2640
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' ******************************************************************************
' *     Fire-Lines  2011                                                      *
' *     :                                                                *
' *         frmMain                                                            *
' *     :                                                              *
' *             ,    Thumbs.db    *
' *                ,        *
' *          ,         *
' *          ..                                                             *
' *     :                                                                 *
' *           (firehacker)                                  *
' *      :                                                     *
' *         *   2011-06-23  firehacker   .                           *
' *      : 1.0.0                                                  *
' *                                                                            *
' ******************************************************************************

Private Type TH_CATALOG_HEADER
    I_dont_known_what_is_it     As Long
    Count                       As Long
    Width                       As Long
    Height                      As Long
End Type

Private Type TH_CATALOG_RECORD
    I_dont_known_what_is_it     As Long
    Id                          As Long
    ModifiedDataLow             As Long
    ModifiedDateHi              As Long
    '         
End Type

Private Type TH_THUMBNAIL_HEADER
    HeaderSize                  As Long
    ImageType                   As Long
    DataSize                    As Long
End Type

Private ThRootStorage           As IStorage
Private ThCatalog               As IStream
Private CatalogHdr              As TH_CATALOG_HEADER

Private Sub cmdSelect_Click()
    comdlg.flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly Or cdlOFNLongNames
    comdlg.CancelError = True
    
    On Error GoTo eh
    comdlg.ShowOpen
    
    tbStorageFileName.Text = comdlg.FileName
    CloseDatabase
    OpenDatabase comdlg.FileName
eh:
End Sub

Private Sub OpenDatabase(ByRef pFileName As String)
    Dim i As Long
    Dim r As TH_CATALOG_RECORD
    Dim w As Integer
    Dim FileNameString As String
    Dim FileNameLength As Long
    
    
    'On Error GoTo eh
    
    '
    '    .
    '
    
    Set ThRootStorage = StgOpenStorage(pFileName, _
                                       Nothing, _
                                       STGM_READWRITE Or STGM_SHARE_DENY_NONE Or STGM_TRANSACTED, _
                                       vbNullString)
                                       
    '
    '    -.
    '
    
    Set ThCatalog = ThRootStorage.OpenStream("Catalog", _
                                             0, _
                                             STGM_READ Or STGM_SHARE_EXCLUSIVE)
                                              
    '
    '   .
    '
    
    ThCatalog.Read CatalogHdr, Len(CatalogHdr)
    
    '
    '   ,    .
    '
    
    For i = 0 To CatalogHdr.Count - 1
        ThCatalog.Read r, Len(r)
        
        '
        '    ,       
        '    .     .  
        '         .
        '
        
        FileNameLength = 0
        Do
            FileNameLength = FileNameLength + 1
            ThCatalog.Read w, LenB(w)
        Loop Until w = 0
        
        '
        ' ,   ,     , 
        '      .
        '
        
        If Len(FileNameString) <> FileNameLength - 1 Then
            FileNameString = Space(FileNameLength - 1)
        End If
        
        ThCatalog.Seek LongToI64(-FileNameLength * Len(w)), STREAM_SEEK_CUR
        ThCatalog.Read ByVal StrPtr(FileNameString), FileNameLength * Len(w)
        
        '
        '       WORD.  .
        '
        
        ThCatalog.Seek LongToI64(Len(w)), STREAM_SEEK_CUR
        
        
        '
        '    .
        '
        
        lbThumbnails.AddItem "[" & r.Id & "] " & FileNameString, i
        lbThumbnails.ItemData(i) = r.Id
    Next i
    
    
    Exit Sub
eh:
    Stop
End Sub

Private Function GetThumbnail(ByVal Id As Long) As IPictureDisp
    Dim ThStream As IStream
    Dim Hdr As TH_THUMBNAIL_HEADER
    Dim IID_IPictureDisp As UUID: CLSIDFromString IIDSTR_IPictureDisp, IID_IPictureDisp
    
    '
    '   ,  .
    '
    
    Set ThStream = ThRootStorage.OpenStream(StrReverse(CStr(Id)), _
                                            0, _
                                            STGM_READ Or STGM_SHARE_EXCLUSIVE)
    
    '
    '       - ,  ,  
    '         .     
    '  .  .
    '
    
    ThStream.Read Hdr, Len(Hdr)
    
    '
    '     .
    '
    
    ThStream.Seek LongToI64(Hdr.HeaderSize), STREAM_SEEK_SET
    Set GetThumbnail = olelib.OleLoadPicture(ThStream, Hdr.DataSize, 1, IID_IPictureDisp)
End Function


Private Function LongToI64(ByVal v As Long) As Currency
    LongToI64 = v * 0.0001
End Function


Private Sub lbThumbnails_Click()
    Dim th_pic As IPictureDisp
    
    Set th_pic = GetThumbnail(lbThumbnails.ItemData(lbThumbnails.ListIndex))
    
    '
    '    .
    '
    
    pbThumbnailImage.Cls
    pbThumbnailImage.PaintPicture th_pic, _
                                  (pbThumbnailImage.ScaleWidth - th_pic.Width / 100) / 2, _
                                  (pbThumbnailImage.ScaleHeight - th_pic.Height / 100) / 2
    
End Sub



Public Sub CloseDatabase()
    lbThumbnails.Clear
    Set ThRootStorage = Nothing
    Set ThCatalog = Nothing
    pbThumbnailImage.Cls
End Sub
